'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Provider = require('react-redux/lib/components/Provider');

var _Provider2 = _interopRequireDefault(_Provider);

var _Router = require('react-router/lib/Router');

var _Router2 = _interopRequireDefault(_Router);

var _RouterContext = require('react-router/lib/RouterContext');

var _RouterContext2 = _interopRequireDefault(_RouterContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var RouterProvider = function RouterProvider(_ref) {
  var client = _ref.client;
  var store = _ref.store;

  var otherProps = _objectWithoutProperties(_ref, ['client', 'store']);

  var RouterComponent = client ? _Router2.default : _RouterContext2.default;

  return _react2.default.createElement(
    _Provider2.default,
    { store: store },
    _react2.default.createElement(RouterComponent, _extends({}, otherProps, {
      history: undefined
    }))
  );
};

RouterProvider.propTypes = {
  store: _react.PropTypes.object.isRequired,
  client: _react.PropTypes.bool
};

exports.default = RouterProvider;