'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reactRouter = require('react-router');

var _reactRouterRedux = require('react-router-redux');

var _configureStore = require('./configureStore');

var _configureStore2 = _interopRequireDefault(_configureStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var bootstrap = function bootstrap(_ref) {
  var history = _ref.history;
  var location = _ref.location;
  var getRoutes = _ref.getRoutes;
  var reducers = _ref.reducers;
  var middlewares = _ref.middlewares;
  var composes = _ref.composes;
  var initialState = _ref.initialState;

  var store = (0, _configureStore2.default)({
    history: history,
    reducers: reducers,
    middlewares: middlewares,
    composes: composes,
    initialState: initialState
  });

  return new Promise(function (resolve, reject) {
    (0, _reactRouter.match)({
      location: location,
      routes: getRoutes(store),
      history: (0, _reactRouterRedux.syncHistoryWithStore)(history, store)
    }, function (error, redirectLocation, renderProps) {
      if (redirectLocation) {
        return resolve({
          redirectLocation: redirectLocation
        });
      }

      if (renderProps) {
        return resolve(_extends({}, renderProps, {
          store: store
        }));
      }

      return reject(error || 'Not match');
    });
  });
};

exports.default = bootstrap;