'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _match = require('react-router/lib/match');

var _match2 = _interopRequireDefault(_match);

var _sync = require('react-router-redux/lib/sync');

var _sync2 = _interopRequireDefault(_sync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var match = function match(_ref) {
  var location = _ref.location;
  var history = _ref.history;
  var store = _ref.store;
  var routes = _ref.routes;

  var finalHistory = (0, _sync2.default)(history, store);

  return new Promise(function (resolve, reject) {
    (0, _match2.default)({
      location: location,
      routes: routes,
      history: finalHistory
    }, function (error, redirectLocation, renderProps) {
      if (error) {
        reject(error);
      } else if (redirectLocation) {
        resolve({
          renderProps: renderProps,
          redirectLocation: redirectLocation
        });
      } else {
        resolve({
          renderProps: _extends({}, renderProps, {
            store: store
          }),
          redirectLocation: redirectLocation
        });
      }
    });
  });
};

exports.default = match;